import {world, system, EquipmentSlot, ItemStack, EntityEquippableComponent} from "@minecraft/server";

world.beforeEvents.itemUseOn.subscribe(use =>{
	try{
		let p = use.source;
		let item = use.itemStack;
		let block = use.block;
		let l = [block.location.x, block.location.y, block.location.z]
		let hoe = ["grass", "dirt"]
		for(let ids of hoe){
			if(item.typeId.includes("new:")){
				if(item.typeId.includes("_hoe")){
					if(block.typeId.includes(`minecraft:${ids}`)){
						system.run(()=>{
							if(!p.hasTag("hoe")){
								p.addTag("hoe")
								p.runCommandAsync(`fill ${l[0]} ${l[1]} ${l[2]} ${l[0]} ${l[1]} ${l[2]} farmland [] replace ${ids}`)
								durability(p, "mainhand", item, "hoe")
							}
						})
					}
				}
				if(item.typeId.includes("_shovel")){
					if(block.typeId.includes(`minecraft:${ids}`)){
						system.run(()=>{
							if(!p.hasTag("shovel")){
								p.addTag("shovel")
								p.runCommandAsync(`fill ${l[0]} ${l[1]} ${l[2]} ${l[0]} ${l[1]} ${l[2]} grass_path [] replace ${ids}`)
								durability(p, "mainhand", item, "shovel")
							}
						})
					}
				}
			}
		}
		let axe = ["acacia", "oak", "spruce", "jungle", "dark_oak", "birch", "mangrove", "cherry"]
		for(let ids of axe){
			if(item.typeId.includes("new:")){
				if(item.typeId.includes("_axe")){
					if(block.typeId.includes(`minecraft:${ids}_log`)){
						system.run(()=>{
							if(!p.hasTag("axe")){
								p.addTag("axe")
								p.runCommandAsync(`fill ${l[0]} ${l[1]} ${l[2]} ${l[0]} ${l[1]} ${l[2]} stripped_${ids}_log [] replace ${ids}_log`)
								durability(p, "mainhand", item, "axe")
							}
						})
					}
				}
			}
		}

	}catch(e){
	}
});

world.beforeEvents.playerBreakBlock.subscribe(b =>{
	try{
		let p = b.player;
		let block = b.block
		let item = b.itemStack;
		let itemsType = ["_axe", "_pickaxe", "_sword", "_hoe", "_knife", "_shovel"]
		for(let types of itemsType){
			if(item.typeId.includes("new:")){
				if(item.typeId.includes(types)){
					system.run(()=>{
						if(!p.hasTag("pickaxe")){
							p.addTag("pickaxe")
							durability(p, "mainhand", item, "pickaxe")
						}
					})
				}
			}
		}
	}catch(e){}
})


let shieldType = ["obsidian", "emerald", "quartz", "prismarine"]

world.afterEvents.entityHurt.subscribe(h =>{
	try{
		let p = h.damageSource.damagingEntity;
		let hurt = h.hurtEntity;
		let itemsType = ["_axe", "_pickaxe", "_sword", "_hoe", "_knife", "_shovel"]
		let armorType = ["obsidian", "prismarine", "emerald", "quartz"]

		if(p.typeId == "minecraft:player"){
			let equip = p.getComponent(EntityEquippableComponent.componentId);
			let item = equip.getEquipment(EquipmentSlot.Mainhand);
			for(let types of itemsType){
				if(item.typeId.includes("new:")){
					if(item.typeId.includes(types)){
						system.run(()=>{
							if(!p.hasTag("attack")){
								p.addTag("attack")
								durability(p, "mainhand", item, "attack")
							}
						})
					}
				}
			}
		}
		if(hurt.typeId == "minecraft:player"){
			let equip = hurt.getComponent(EntityEquippableComponent.componentId);
			let item = equip?.getEquipment(EquipmentSlot.Mainhand);
			let offhand = equip?.getEquipment(EquipmentSlot.Offhand);
			let head = equip?.getEquipment(EquipmentSlot.Head);
			let chest = equip?.getEquipment(EquipmentSlot.Chest);
			let legs = equip?.getEquipment(EquipmentSlot.Legs);
			let feet = equip?.getEquipment(EquipmentSlot.Feet);
			for(let types of shieldType){
				if(head){
					if(head.typeId.includes(`${types}_helmet`)){
						if(!hurt.hasTag("head")){
							hurt.addTag("head")
							durability(hurt, "head", head, "head")
						}
					}
				}
				if(chest){
					if(chest.typeId.includes(`${types}_chestplate`)){
						if(!hurt.hasTag("chestplate")){
							hurt.addTag("chestplate")
							durability(hurt, "chest", chest, "chestplate")
						}
					}
				}
				if(legs){
					if(legs.typeId.includes(`${types}_leggings`)){
						if(!hurt.hasTag("leggings")){
							hurt.addTag("leggings")
							durability(hurt,"legs", legs, "leggings")
						}
					}
				}
				if(feet){
					if(feet.typeId.includes(`${types}_boots`)){
						if(!hurt.hasTag("feet")){
							hurt.addTag("feet")
							durability(hurt, "feet", feet, "feet")
						}
					}
				}
				if(item && !hurt.hasTag("offhand")){
					if(item.typeId.includes("new:")){
						if(hurt.isSneaking){
							if(item.typeId.includes(`${types}_shield`)){
								system.run(()=>{
									if(!hurt.hasTag("item")){
										hurt.addTag("item");
										hurt.runCommandAsync("gamerule sendcommandfeedback false")
										durability(hurt, "mainhand", item, "item")
										hurt.runCommandAsync("tp ~~~")
										hurt.runCommandAsync(`playsound random.${types}_shield`)
										hurt.runCommandAsync("gamerule sendcommandfeedback true")
									}
								})
							}
						}
					}
				}
				if(offhand){
					if(offhand.typeId.includes("new:")){
						if(hurt.isSneaking){
							if(offhand.typeId.includes(`${types}_shield`)){
								system.run(()=>{
									if(hurt.hasTag("shield")){
										p.addTag("shield");
										hurt.runCommandAsync("gamerule sendcommandfeedback false")
										durability(hurt, "offhand", offhand, "shield")
										hurt.runCommandAsync("tp ~~~")
										hurt.runCommandAsync(`playsound random.${types}_shield`)
										hurt.runCommandAsync("gamerule sendcommandfeedback true")
										hurt.runCommandAsync("summon new:knockback ~~~")
									}
								})
							}
						}
					}
				}
			}

			let thorns = 0;
			if(head || chest || legs || feet){
				if(head.typeId.includes(`quartz_helmet`)){
					thorns += 2;
				}
				if(chest.typeId.includes(`quartz_chestplate`)){
					thorns += 2;
				}
				if(legs.typeId.includes(`quartz_leggings`)){
					thorns += 2;
				}
				if(feet.typeId.includes(`quartz_boots`)){
					thorns += 2;
				}
			}
			if(thorns > 0){
				p.runCommandAsync(`damage @s ${thorns}`)
			}
		}
	}catch(e){
	}
})

system.runInterval(() =>{
	try{
		for(let p of world.getPlayers()){
			p.runCommandAsync("function armor_effects")
			let itemsType = ["axe", "pickaxe", "sword", "hoe", "knife", "shovel", "shield"]
			let armorType = ["helmet", "boots", "leggings", "chestplate"]
			let inv = p.getComponent("inventory").container;



			for(let slot = 0; slot < inv.size; slot++){
				let item = inv.getItem(slot);
				if(item){
					if(item.typeId.includes("new:")){
						let durability = item.getComponent("durability").damage;
						let maxDurability = item.getComponent("durability").maxDurability;
						let lore0 = item.getLore()[0];
						for(let armor of armorType){
							if(item.typeId.includes(`prismarine_${armor}`)){
								if(!lore0){
									item.setLore([`\n§dDurability: §7${maxDurability-durability}/${maxDurability}`, `§7Conduit Power Effect I (Lvl IV with full set)§r`])
									inv.setItem(slot, item)
								}
							}
							if(item.typeId.includes(`obsidian_${armor}`)){
								if(!lore0){
									item.setLore([`\n§dDurability: §7${maxDurability-durability}/${maxDurability}`, `§7Fire Resistance I (Lvl IV with full set)`, `§r§7Immune to Fire and Lava§r`])
									inv.setItem(slot, item)
								}
							}
							if(item.typeId.includes(`emerald_${armor}`)){
								if(!lore0){
									item.setLore([`\n§dDurability: §7${maxDurability-durability}/${maxDurability}`, `§7Village Hero Effect I (Lvl IV with full set)§r`])
									inv.setItem(slot, item)
								}
							}
							if(item.typeId.includes(`quartz_${armor}`)){
								if(!lore0){
									item.setLore([`\n§dDurability: §7${maxDurability-durability}/${maxDurability}`, `§7+2 Thorn Damage (+8 with full set)§r`])
									inv.setItem(slot, item)
								}
							}
						}
						for(let types of itemsType){
							if(item.typeId.includes(`obsidian_${types}`)){
								if(!lore0){
									item.setLore([`\n§dDurability: §7${maxDurability-durability}/${maxDurability}`, `§r§7Immune to Fire and Lava§r`])
									inv.setItem(slot, item)
								}
							}
							if(item.typeId.includes(`emerald_${types}`)){
								if(!lore0){
									item.setLore([`\n§dDurability: §7${maxDurability-durability}/${maxDurability}`, ""])
									inv.setItem(slot, item)
								}
							}
							if(item.typeId.includes(`quartz_${types}`)){
								if(!lore0){
									item.setLore([`\n§dDurability: §7${maxDurability-durability}/${maxDurability}`, ""])
									inv.setItem(slot, item)
								}
							}
							if(item.typeId.includes(`prismarine_${types}`)){
								if(!lore0){
									item.setLore([`\n§dDurability: §7${maxDurability-durability}/${maxDurability}`, ""])
									inv.setItem(slot, item)
								}
							}
							if(item.typeId.includes(`flint_${types}`)){
								if(!lore0){
									item.setLore([`\n§dDurability: §7${maxDurability-durability}/${maxDurability}`, ""])
									inv.setItem(slot, item)
								}
							}
						}

					}
				}
			}

			let equip = p.getComponent(EntityEquippableComponent.componentId);
			let hand = equip.getEquipment(EquipmentSlot.Mainhand);
			let offhand = equip.getEquipment(EquipmentSlot.Offhand);
			let head = equip?.getEquipment(EquipmentSlot.Head);
			let chest = equip?.getEquipment(EquipmentSlot.Chest);
			let legs = equip?.getEquipment(EquipmentSlot.Legs);
			let feet = equip?.getEquipment(EquipmentSlot.Feet);
			if(hand){
				for(let types of shieldType){
					if(hand.typeId.includes(`${types}_shield`)){
						if(p.isSneaking){
							p.runCommandAsync("effect @s resistance 1 255 true")
						}
					}
				}
			}
			if(hand == undefined){
				p.removeTag("offhand")
			}
			if(offhand){
				for(let types of shieldType){
					if(offhand.typeId.includes(`${types}_shield`)){
						p.addTag("offhand")
						if(p.isSneaking){
							p.runCommandAsync("effect @s resistance 1 255 true")
						}
					}
				}
			}




			if(head){
				let durability = head.getComponent("durability").damage;
				let maxDurability = head.getComponent("durability").maxDurability;
				let lore0 = head.getLore()[0];
				if(head.typeId.includes(`prismarine_helmet`)){
					if(!lore0){
						head.setLore([`\n§dDurability: §7${maxDurability-durability}/${maxDurability}`, `§7Conduit Power Effect I (Lvl IV with full set)§r`, ""])
						equip.setEquipment(EquipmentSlot.Head, head)
					}
				}
				if(head.typeId.includes(`obsidian_helmet`)){
					if(!lore0){
						head.setLore([`\n§dDurability: §7${maxDurability-durability}/${maxDurability}`, `§7Fire Resistance I (Lvl IV with full set)`, `§r§7Immune to Fire and Lava§r`])
						equip.setEquipment(EquipmentSlot.Head, head)
					}
				}
				if(head.typeId.includes(`emerald_helmet`)){
					if(!lore0){
						head.setLore([`\n§dDurability: §7${maxDurability-durability}/${maxDurability}`, `§7Village Hero Effect I (Lvl IV with full set)§r`, ""])
						equip.setEquipment(EquipmentSlot.Head, head)
					}
				}
				if(head.typeId.includes(`quartz_helmet`)){
					if(!lore0){
						head.setLore([`\n§dDurability: §7${maxDurability-durability}/${maxDurability}`, `§7+2 Thorn Damage (+8 with full set)§r`, ""])
						equip.setEquipment(EquipmentSlot.Head, head)
					}
				}
			}
			if(chest){
				let durability = chest.getComponent("durability").damage;
				let maxDurability = chest.getComponent("durability").maxDurability;
				let lore0 = chest.getLore()[0];
				if(chest.typeId.includes(`prismarine_chestplate`)){
					if(!lore0){
						chest.setLore([`\n§dDurability: §7${maxDurability-durability}/${maxDurability}`, `§7Conduit Power Effect I (Lvl IV with full set)§r`, ""])
						equip.setEquipment(EquipmentSlot.Chest, chest)
					}
				}
				if(chest.typeId.includes(`obsidian_chestplate`)){
					if(!lore0){
						chest.setLore([`\n§dDurability: §7${maxDurability-durability}/${maxDurability}`, `§7Fire Resistance I (Lvl IV with full set)`, `§r§7Immune to Fire and Lava§r`])
						equip.setEquipment(EquipmentSlot.Chest, chest)
					}
				}
				if(chest.typeId.includes(`emerald_chestplate`)){
					if(!lore0){
						chest.setLore([`\n§dDurability: §7${maxDurability-durability}/${maxDurability}`, `§7Village Hero Effect I (Lvl IV with full set)§r`, ""])
						equip.setEquipment(EquipmentSlot.Chest, chest)
					}
				}
				if(chest.typeId.includes(`quartz_chestplate`)){
					if(!lore0){
						chest.setLore([`\n§dDurability: §7${maxDurability-durability}/${maxDurability}`, `§7+2 Thorn Damage (+8 with full set)§r`, ""])
						equip.setEquipment(EquipmentSlot.Chest, chest)
					}
				}
			}

			if(legs){
				let durability = legs.getComponent("durability").damage;
				let maxDurability = legs.getComponent("durability").maxDurability;
				let lore0 = legs.getLore()[0];
				if(legs.typeId.includes(`prismarine_leggings`)){
					if(!lore0){
						legs.setLore([`\n§dDurability: §7${maxDurability-durability}/${maxDurability}`, `§7Conduit Power Effect I (Lvl IV with full set)§r`, ""])
						equip.setEquipment(EquipmentSlot.Legs, legs)
					}
				}
				if(legs.typeId.includes(`obsidian_leggings`)){
					if(!lore0){
						legs.setLore([`\n§dDurability: §7${maxDurability-durability}/${maxDurability}`, `§7Fire Resistance I (Lvl IV with full set)`, `§r§7Immune to Fire and Lava§r`])
						equip.setEquipment(EquipmentSlot.Legs, legs)
					}
				}
				if(legs.typeId.includes(`emerald_leggings`)){
					if(!lore0){
						legs.setLore([`\n§dDurability: §7${maxDurability-durability}/${maxDurability}`, `§7Village Hero Effect I (Lvl IV with full set)§r`, ""])
						equip.setEquipment(EquipmentSlot.Legs, legs)
					}
				}
				if(legs.typeId.includes(`quartz_leggings`)){
					if(!lore0){
						legs.setLore([`\n§dDurability: §7${maxDurability-durability}/${maxDurability}`, `§7+2 Thorn Damage (+8 with full set)§r`, ""])
						equip.setEquipment(EquipmentSlot.Legs, legs)
					}
				}
			}
			if(feet){
				let durability = feet.getComponent("durability").damage;
				let maxDurability = feet.getComponent("durability").maxDurability;
				let lore0 = feet.getLore()[0];
				if(feet.typeId.includes(`prismarine_boots`)){
					if(!lore0){
						feet.setLore([`\n§dDurability: §7${maxDurability-durability}/${maxDurability}`, `§7Conduit Power Effect I (Lvl IV with full set)§r, ""`])
						equip.setEquipment(EquipmentSlot.Feet, feet)
					}
				}
				if(feet.typeId.includes(`obsidian_boots`)){
					if(!lore0){
						feet.setLore([`\n§dDurability: §7${maxDurability-durability}/${maxDurability}`, `§7Fire Resistance I (Lvl IV with full set)`, `§r§7Immune to Fire and Lava§r`])
						equip.setEquipment(EquipmentSlot.Feet, feet)
					}
				}
				if(feet.typeId.includes(`emerald_boots`)){
					if(!lore0){
						feet.setLore([`\n§dDurability: §7${maxDurability-durability}/${maxDurability}`, `§7Village Hero Effect I (Lvl IV with full set)§r`, ""])
						equip.setEquipment(EquipmentSlot.Feet, feet)
					}
				}
				if(feet.typeId.includes(`quartz_boots`)){
					if(!lore0){
						feet.setLore([`\n§dDurability: §7${maxDurability-durability}/${maxDurability}`, `§7+2 Thorn Damage (+8 with full set)§r`, ""])
						equip.setEquipment(EquipmentSlot.Feet, feet)
					}
				}
			}
		}
	}catch(e){}
})


function durability(p, slot, item, tag) {
	try{
		if (p.matches({ excludeGameModes: ['creative'] })) {
			system.runTimeout(() =>{
				let equip = p.getComponent(EntityEquippableComponent.componentId);
				let hand = equip?.getEquipment(EquipmentSlot.Mainhand);
				let offhand = equip?.getEquipment(EquipmentSlot.Offhand);
				let durability = item.getComponent("durability").damage;
				let maxDurability = item.getComponent("durability").maxDurability;
				let lore = item.getLore()[0]
				let lore1 = item.getLore()[1]
				let lore2 = item.getLore()[2]
				p.removeTag(tag);
				let damage = parseFloat(lore.replace("\n§dDurability: §7", "").split(`/${maxDurability}`))
				if(damage > 0){
					if(slot == "mainhand"){
						item.setLore([`\n§dDurability: §7${damage-1}/${maxDurability}`, lore1 ])
						p.runCommandAsync(`title @s actionbar §bItem: §f${hand.typeId.replace("new:", "")}\n§dDurability: §f${damage-1}/${maxDurability}`)
						equip.setEquipment(EquipmentSlot.Mainhand, item)
					}
					if(slot == "offhand"){
						item.setLore([`\n§dDurability: §7${damage-1}/${maxDurability}`, lore1 ])
						p.runCommandAsync(`title @s actionbar §bItem: §f${offhand.typeId.replace("new:", "")}\n§dDurability: §f${damage-1}/${maxDurability}`)
						equip.setEquipment(EquipmentSlot.Offhand, item)
					}
					if(slot == "head"){
						item.setLore([`\n§dDurability: §7${damage-1}/${maxDurability}`, lore1, lore2 ])
						equip.setEquipment(EquipmentSlot.Head, item)
					}
					if(slot == "chest"){
						item.setLore([`\n§dDurability: §7${damage-1}/${maxDurability}`, lore1, lore2 ])
						equip.setEquipment(EquipmentSlot.Chest, item)
					}
					if(slot == "legs"){
						item.setLore([`\n§dDurability: §7${damage-1}/${maxDurability}`, lore1, lore2 ])
						equip.setEquipment(EquipmentSlot.Legs, item)
					}
					if(slot == "feet"){
						item.setLore([`\n§dDurability: §7${damage-1}/${maxDurability}`, lore1, lore2 ])
						equip.setEquipment(EquipmentSlot.Feet, item)
					}
				}
				if(damage < 2){
					p.runCommandAsync("playsound random.break @s")
					p.runCommandAsync(`replaceitem entity @s slot.weapon.${slot} 0 air`)
				}
			}, 2)
		}
	}catch(e){
	}
}
